package com.argot.blink;

import com.argot.auto.ArgotMarshaller;
import com.argot.auto.ArgotTag;

@ArgotMarshaller(ArgotMarshaller.Marshaller.ANNOTATION)
public class Packet 
{
	public static final String TYPENAME = "blink.packet";
	
	@ArgotTag("start")
	public int soh;
	
	@ArgotTag("length")
	public int length;
	
	@ArgotTag("command")
	public int command;
	
	@ArgotTag("milliseconds")
	public int milliseconds;
	
	
	public Packet(Command command, int milliseconds)
	{
		// Marker for start of packet is letter a.
		soh = ('a');
		
		// A little hack for the demo.  There are better ways for setting length, but
		// this is ok for a simple packet structure.
		// Length is command id + 2 bytes for on/off values.
		length = 3;
		this.command = command.id();
		this.milliseconds = milliseconds;
	}
	
	public Packet()
	{
		// Empty constructor required for annotation marshaller.
	}
	
	// Enumerated command.
	// 
	public enum Command
	{
		SET_DELAY_ON (0),
		SET_DELAY_OFF (1);
		
		private final int id;
		
		Command(int id) {
			this.id = id;
		}
		
		public int id() {
			return id;
		}
	}
	
}
